#! /bin/sh 
#
# Licensed Materials - Property of IBM
# OCO Source Materials
# 
# (C) Copyright IBM Corp. 2011 All Rights Reserved
# The source code for this program is not published or otherwise divested of its 
# trade secrets, irrespective of what has been deposited with the U.S. Copyright Office.
#

export TEXTDOMAINDIR=/usr/share/locale
export TEXTDOMAIN=chnetcfgFSMcheck
. /usr/bin/gettext.sh

DIRECTOR_ROOT=/opt/ibm/director
FRM_LIB=$DIRECTOR_ROOT/lwi/runtime/itme/eclipse/plugins
OSGI_LIB=$DIRECTOR_ROOT/lwi/runtime/core/eclipse/plugins
JAVA_EXE=/opt/ibm/java-i386-60/jre/bin/java
TOOL_PGM=com.ibm.itme.security.policy.ChnetcfgFSMcheck
TRANSFER_VAL=xxxx
SERVICE_VAL=yyy
STATE_VAL=zzz
APP_NAME=aaaaa
INTERFACE=iiii
ANY_DHCP_PARM=dddd
RET=0

# Need to set the path for the jre/jvm
export PATH=/usr/lib64/jvm/java-1.5.0-ibm/bin:$PATH

MESSAGE_UTIL_JAR=$(find "/opt/ibm/director/lwi/runtime/USMiResource/eclipse/plugins" -name com.ibm.director.core.common_*.jar | tail -n 1)
TOOL_CLASSPATH=$TOOL_CLASSPATH$MESSAGE_UTIL_JAR:

#for f in $( find "$FRM_LIB" -name "*.jar" ); do
#  TOOL_CLASSPATH=$TOOL_CLASSPATH$f:
#done
FSM_COMMON_JAR=$(find "/opt/ibm/director/lwi/runtime/itme/eclipse/plugins" -name common.jar | tail -n 1)
FSM_UTIL_JAR=$(find "/opt/ibm/director/lwi/runtime/itme/eclipse/plugins" -name utils.jar | tail -n 1)
FSM_SECURITY_JAR=$(find "/opt/ibm/director/lwi/runtime/itme/eclipse/plugins" -name security.jar | tail -n 1)
FSM_TASKS_JAR=$(find "/opt/ibm/director/lwi/runtime/itme/eclipse/plugins" -name tasks.jar | tail -n 1)
FSM_USERMGMT_JAR=$(find "/opt/ibm/director/lwi/runtime/itme/eclipse/plugins" -name com.ibm.itme.usermgmt.jar | tail -n 1)
ASPECTJ_JAR=$(find "/opt/ibm/director/lwi/runtime/itme/eclipse/plugins" -name aspectjrt.jar | tail -n 1)

FSM_JARS=$FSM_SECURITY_JAR:$FSM_UTIL_JAR:$FSM_TASKS_JAR:$FSM_USERMGMT_JAR:$FSM_COMMON_JAR:$ASPECTJ_JAR:

CORE_KERNEL_JAR=$(find "/opt/ibm/director/lwi/runtime/USMiMain/eclipse/plugins" -name core-kernel.jar | tail -n 1)
TOOL_CLASSPATH=$FSM_JARS:$CORE_KERNEL_JAR:$MESSAGE_UTIL_JAR:


for f in $( find "$OSGI_LIB" -name "org.eclipse.osgi_*" ); do
 TOOL_CLASSPATH=$TOOL_CLASSPATH$f:
done

#echo "classpath is $TOOL_CLASSPATH"

while [ "$#" -ne "0" ]; do
    case $1 in
     -t)     TRANSFER_VAL=$2 
             ;;
     -c)     SERVICE_VAL=$2 
             ;;
     -s)     STATE_VAL=$2 
             ;;
    --app-name)  APP_NAME=$2 
             ;;
    -i)      INTERFACE=$2 
             ;;
    --start-ip-address)  ANY_DHCP_PARM=$2 
             ;;
    --dhcp-client)  ANY_DHCP_PARM=$2 
             ;;

    esac
    shift
done
#echo "*****************New Entry*******************" >> /home/checkfsm.log

# Call the java program 
OPT1=-Djava.util.logging.config.file=/opt/ibm/director/itme/logging.properties
OPT2="-Xdebug -Xrunjdwp:transport=dt_socket,address=8001,server=y,suspend=y"

#echo "command is $JAVA_EXE -cp $TOOL_PGM $SERVICE_VAL $STATE_VAL $TRANSFER_VAL $APP_NAME $INTERFACE $ANY_DHCP_PARM || RET=$?"
#$JAVA_EXE -cp  $TOOL_CLASSPATH $TOOL_PGM $SERVICE_VAL $STATE_VAL $TRANSFER_VAL $APP_NAME $INTERFACE $ANY_DHCP_PARM || RET=$? 
$JAVA_EXE  -cp  $TOOL_CLASSPATH $TOOL_PGM $SERVICE_VAL $STATE_VAL $TRANSFER_VAL $APP_NAME $INTERFACE $ANY_DHCP_PARM || RET=$? 

if [ $RET -ne 1 ];
then
#printf "`gettext 'SUCCESS - Parameters are OK'`\n"
exit 0
else
#printf "`gettext 'FAILED - Parameters need to be secure'`\n"

exit 1
fi
