#!/bin/sh
#
# Licensed Materials - Property of IBM
#
# OCO Source Materials
#
# (C) Copyright IBM Corp. 2011 All Rights Reserved
#
# The source code for this program is not published or other-
# wise divested of its trade secrets, irrespective of what has
# been deposited with the U.S. Copyright Office.
#

if [ $# -eq 2 ]; then
User=$1
Password=$2
else
echo "Usage: provide the following 2 parameters separated by spaces: userid password"
echo "Usage: provide the following 2 parameters separated by spaces: userid password" >> /var/log/networkadvisorConfig.out 2>&1
exit 1
fi
echo 'begin' >> /var/log/networkadvisorConfig.out
/opt/networkadvisor/bin/silentInstall >> /var/log/networkadvisorConfig.out 2>&1	
cd /opt/networkadvisor/bin/
./useraccount -add $User $Password >> /var/log/networkadvisorConfig.out 2>&1
./useraccount -delete Administrator >> /var/log/networkadvisorConfig.out 2>&1
./dbpasswd dcmadmin passw0rd $Password $Password >> /var/log/networkadvisorConfig.out 2>&1
/opt/ibm/director/itme/apps/networkadvisor/stopServer >> /var/log/networkadvisorConfig.out 2>&1

#Disable medium and weak ciphers for BNA
#Check for restricted ciphers and if not found add
if ! grep cipher /opt/networkadvisor/jboss/server/dcm/deploy/jbossweb.sar/server.xml
then
  sed -i '/SSLImplementation/ a\ciphers="TLS_RSA_WITH_AES_128_CBC_SHA,TLS_DHE_RSA_WITH_AES_128_CBC_SHA,TLS_DHE_DSS_WITH_AES_128_CBC_SHA,SSL_RSA_WITH_3DES_EDE_CBC_SHA,SSL_DHE_RSA_WITH_3DES_EDE_CBC_SHA,SSL_DHE_DSS_WITH_3DES_EDE_CBC_SHA"' /opt/networkadvisor/jboss/server/dcm/deploy/jbossweb.sar/server.xml
fi

if ! grep cipher /opt/networkadvisor/conf/security/deploy/jbossweb.sar/server-ssl.xml
then
  sed -i '/SSLImplementation/ a\ciphers="TLS_RSA_WITH_AES_128_CBC_SHA,TLS_DHE_RSA_WITH_AES_128_CBC_SHA,TLS_DHE_DSS_WITH_AES_128_CBC_SHA,SSL_RSA_WITH_3DES_EDE_CBC_SHA,SSL_DHE_RSA_WITH_3DES_EDE_CBC_SHA,SSL_DHE_DSS_WITH_3DES_EDE_CBC_SHA"' /opt/networkadvisor/conf/security/deploy/jbossweb.sar/server-ssl.xml
fi

if ! grep cipher /opt/networkadvisor/bin/server.xml
then
  sed -i '/SSLImplementation/ a\ciphers="TLS_RSA_WITH_AES_128_CBC_SHA,TLS_DHE_RSA_WITH_AES_128_CBC_SHA,TLS_DHE_DSS_WITH_AES_128_CBC_SHA,SSL_RSA_WITH_3DES_EDE_CBC_SHA,SSL_DHE_RSA_WITH_3DES_EDE_CBC_SHA,SSL_DHE_DSS_WITH_3DES_EDE_CBC_SHA"' /opt/networkadvisor/bin/server.xml
fi

head -n 25 /opt/networkadvisor/jboss/server/dcm/deploy/jbossweb.sar/server.xml >> /var/log/networkadvisorConfig.out
echo '/opt/networkadvisor/bin/server.xml' >> /var/log/networkadvisorConfig.out
head -n 25 /opt/networkadvisor/bin/server.xml >> /var/log/networkadvisorConfig.out
echo 'end' >> /var/log/networkadvisorConfig.out
exit 0
