/*
 * Licensed Materials - Property of IBM
 *
 * OCO Source Materials
 *
 * (C) Copyright IBM Corp. 2012 All Rights Reserved
 *
 * The source code for this program is not published or other-
 * wise divested of its trade secrets, irrespective of what has
 * been deposited with the U.S. Copyright Office.
 */
define(["dojo/_base/declare",
		"fsm/GeneralActionsMenu",
		"fsm/CommonActionsList",
		"dijit/_WidgetBase",
		"dijit/_TemplatedMixin",
		//Need this because we are declaring a widget in our template
		"dijit/_WidgetsInTemplateMixin",
		//The template definition
		"dojo/text!./templates/CommonActions.html"
		],function (declare, GeneralActionsMenu, CommonActionsList, _WidgetBase, _TemplatedMixin, _WidgetsInTemplateMixin, template) {
	return declare([_WidgetBase, _TemplatedMixin, _WidgetsInTemplateMixin], 
	{		 
		templateString: template,
		_selection: null,
		_commonActionsList: null,
		constructor: function(kwArgs){
			this.inherited(arguments);
		},
		postCreate: function() {
			this.inherited(arguments);
			this.initialize();
		},
		initialize: function() {
			var generalActionMenu = new GeneralActionsMenu({}, "generalActionsContainer");
        	generalActionMenu.createGeneralActionsMenu(); 
        	if(this._selection && this._selection.length > 0) {
        		this._createCommonActions();
        	}
		},
		selectionChanged : function(selection) {
			this._selection = selection;
			if(this._selection && this._selection.length > 0) {
        		this._createCommonActions();
        	}
		},
		_createCommonActions : function() {
			this._commonActionsList = new CommonActionsList({_parentDomNodeId: 'commonActionsContainer', _selection: this._selection});
		},
		startup: function() {
			this.inherited(arguments);
		}			
		
	});
});