define(["dojo/_base/declare","dojo/i18n",
		"fsm/DataStore",
		"dijit/MenuSeparator",
		"dijit/MenuItem", "dijit/form/ComboButton"],
	function (declare, i18n, DataStore, MenuSeparator, MenuItem, ComboButton) {

	return declare([], {
	
	_parentDomNodeId: null,
	_dataStore: null,
	MRI: {GeneralActions: 'General Actions'},
	
	constructor: function(kwArgs, parentDomNodeId){
	  //dojo.requireLocalization("itme", "Resources");
	  //this.MRI = i18n.getLocalization("itme", "Resources");	  
		this._parentDomNodeId = parentDomNodeId;
	},
	
	_doClick: function(taskId, nonInteractive) {		
		var selectedTaskId = taskId;	
		if(nonInteractive === 'true') {
			alert('taskId ' + taskId + ' is a non-interactive task, not supported yet');
			return;
		}		
		launchInContext(selectedTaskId);
		//itmeUtils.CMTrace("CA_MENU", "doclick: " + taskId);

	},
	
	createGeneralActionsMenu: function() {
		 this._dataStore = new DataStore({
                datasetId : 'COMMON_ACTIONS_COLLECTION',
                homeParms : null,
                getItems : true,
                retrieveItemProperties : true,
                getTasks : false,
                initReadyCallback : dojo.hitch(this, this._createTheMenu)
            });
	},
	createElement : function(parentNode, elementId, parms) {
        var newElement;
        if (!parms)
            parms = {};
        var elementType = (parms.elementType) ? parms.elementType : "div";

        if (dojo.byId(elementId))
            return dojo.byId(elementId);

        try {
            newElement = document.createElement(elementType);

            dojo.attr(newElement, "id", elementId);
            if (parms.styleClass)
                dojo.attr(newElement, "class", parms.styleClass);
            if (parms.style)
                dojo.attr(newElement, "style", parms.style);

            // IE hack, we have to clone the node and do future work from the clone
            if (parentNode)
                parentNode.appendChild(newElement.cloneNode(true));
            else
                newElement.cloneNode(true);
            newElement = dojo.byId(elementId);
        } catch (e) {
        	console.error(e);
        }

        if (parms.baseDimensionsOnNode && newElement) {
            var sizeToElementCBox = dojo.contentBox(parms.baseDimensionsOnNode);
            dojo.contentBox(newElement, {
                w : sizeToElementCBox.w,
                h : sizeToElementCBox.h
            });
        }
        if (parms.innerHTML)
            newElement.innerHTML = parms.innerHTML;

        return newElement;
    },
	_createTheMenu: function() {
    try {if ( this._dataStore ) {
      //itmeUtils.CMTrace("CA_MENU", "found DATA node: " + dataNode.innerHTML);
     var menuData = this._dataStore.getItems();
	  
  		var divNode = dojo.byId(this._parentDomNodeId);
  		dojo.addClass(divNode, "soria");
  		dojo.addClass(divNode, "commonActionsDiv");

		//TODO: add utils later
      var buttonContainer = this.createElement(
          "GenActsContainer", 
          divNode, 
          { elementType: "span", innerHTML:'hey',
            styleClass: "GenActsContainer" } );
            
		
  		if (divNode) {
  		  //itmeUtils.CMTrace("CA_MENU", "found DIV node");
			
  			oldButton = dijit.byId("GeneralCommonActionsButton");
  			if ( oldButton )
  				oldButton.destroyRecursive();				
  			
        pMenu = new dijit.Menu({
        });
  	        
        //itmeUtils.CMTrace("CA_MENU", "cat.len: " +  menuData.CATEGORIES.length);
        var lastCategory = "";
        var j = 0;
        for (var i = 0; i < menuData.length; i++) {
          //itmeUtils.CMTrace("CA_MENU", "tasks["+i+"].len: " + menuData.CATEGORIES[i].TASKS.length);
          if (this._dataStore.getItemProperty(menuData[i], "COMMON_ACTION_TYPE") == "COMMON_ACTION") {
          	  continue; 
          }
  		  var category = this._dataStore.getItemProperty(menuData[i], "COMMON_ACTION_CATEGORY_NAME");
  		  var nonInteractive = this._dataStore.getItemProperty(menuData[i], "COMMON_ACTION_NON_INTERACTIVE");
  		  if(category.length == 0) {
  		  	category = "General";
  		  }
          if ( j > 0 && !(category == lastCategory))
              pMenu.addChild(new MenuSeparator({className: "mySeperatorClass"}));
          j++;
          lastCategory = category;
  		  var itemLabel = this._dataStore.getItemProperty(menuData[i], "COMMON_ACTION_NAME");
  		  var itemId = this._dataStore.getItemProperty(menuData[i], "ACTION_ID");
  		  pMenu.addChild(new MenuItem({
                label: itemLabel,
                onClick: dojo.hitch(this, this._doClick, itemId, nonInteractive),
                className: "myTestClass"
            }));
        	
        }
        
        button = new ComboButton({
            label: this.MRI.GeneralActions,
            dropDown: pMenu,
            id: "GeneralCommonActionsButton",
            dropDownPosition: ["below"]
        });
       
        pMenu.startup();	
        buttonContainer.appendChild(button.domNode);
        //itmeUtils.CMTrace("CA_MENU", "/end found DIV node");
  		}
    }
    } catch (error) {
    	console.info(error);
    }
	}

});
});