// dojo.provide allows pages to use all of the types declared in this resource.

define(["dojo/_base/kernel", "ibm/tivoli/tip/TCTTable","framework/OneUIItemsTableView","dojo/_base/declare", "dojo/topic", "dijit/_WidgetBase", 
		"dijit/layout/ContentPane"],
	function (dojo, TCTTable, ItemsTableView, declare, topic, WidgetBase, ContentPane) {

	return declare([WidgetBase, ContentPane], {
	oid: null,
	hardwareView: true,
	_chassisMapDiv :null,
	_goback: null,
	constructor: function (args) {
		this.inherited(arguments);
		this.id = 'chassisMap';
		this.oid = args.oid;
		this._goback = args.goback;
	},
    postCreate : function() {
        this.inherited(arguments);
        console.info('alex1');
        this._createChassisMap();
          
    },
    _createMapDiv: function() {
    	 var chassisMapDiv = document.createElement('div');
		  dojo.attr(chassisMapDiv, "id", 'chassisMapDiv');		
		  this.domNode.appendChild(chassisMapDiv);
		  return chassisMapDiv;
    },
    _createChassisMap : function () {
    	if(this._chassisMapDiv) {
    		this.domNode.removeChild(this._chassisMapDiv);
    		//dojo.destroyRecursive(this._chassisMapDiv);
    	}
    	topic.publish("updateTitle", {view: "graphical view for: " + this.oid});               
    	this._chassisMapDiv = this._createMapDiv();
		var chassisMapLink = document.createElement('span');
		chassisMapLink.innerHTML = 'go to table view';
		dojo.attr(chassisMapLink, "id", 'chassisMapLink');
		dojo.attr(chassisMapLink, "class", 'actionLink');	
		this._chassisMapDiv.appendChild(chassisMapLink);
		this._createGoBackLink();
		var chassisMapDom = document.createElement('div');
		dojo.attr(chassisMapDom, "id", 'chassisMapDom');	
		chassisMapDom.innerHTML = '<BR/><BR/><BR/><h1>this is chassis map</h1>';
		this._chassisMapDiv.appendChild(chassisMapDom);
		dojo.connect(chassisMapLink, 'onclick', dojo.hitch(this, this._chassisMapLinkClicked));
    },
    _createGoBackLink : function () {
    	var gobackLink = document.createElement('span');
		gobackLink.innerHTML = 'go back to chassis list';
		dojo.attr(gobackLink, "id", 'gobacklink');
		dojo.attr(gobackLink, "class", 'actionLink');	
		this._chassisMapDiv.appendChild(gobackLink);
		dojo.connect(gobackLink, 'onclick', this._goback);    
    },
    _createTableView : function () {
    	if(this._chassisMapDiv) {
    		this.domNode.removeChild(this._chassisMapDiv);
    		//dojo.destroy(this._chassisMapDiv);
    	}
    	topic.publish("updateTitle", {view: "table view for: " + this.oid});               
    	this._chassisMapDiv = this._createMapDiv();
		var chassisMapLink = document.createElement('span');
		chassisMapLink.innerHTML = 'go to graphical view';
		dojo.attr(chassisMapLink, "id", 'chassisMapLink');
		dojo.attr(chassisMapLink, "class", 'actionLink');	
		this._chassisMapDiv.appendChild(chassisMapLink);
		var chassisMapDom = document.createElement('div');
		dojo.attr(chassisMapDom, "id", 'chassisMapDom');	
		chassisMapDom.innerHTML = '<BR/><BR/><BR/><h1>this is table view</h1>';
		this._chassisMapDiv.appendChild(chassisMapDom);
		dojo.connect(chassisMapLink, 'onclick', dojo.hitch(this, this._chassisMapTableViewLinkClicked));
    },
    _chassisMapLinkClicked : function() {
		this.hardwareView = false;
		this._createTableView();
    },
    _chassisMapTableViewLinkClicked : function() {
		this.hardwareView = false;
		this._createChassisMap();
    }
});
});